package animcheckboxwrapper;

import main.java.com.github.lguipeng.library.animcheckbox.AnimCheckBox;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("AnimCheckBox")
public class animCheckBoxWrapper extends ViewWrapper<AnimCheckBox> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private AnimCheckBox cv;
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new AnimCheckBox(ba.context,null);
                this.setObject(cv);
//              setEventName(this.eventName);
                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


    @Hide
    public void addListener(){

        cv.setCallback(new AnimCheckBox.Callback() {
            @Override
            public void check_changed() {

              if (ba.subExists(eventName + "_check_changed")) {
                ba.raiseEvent2(ba, false, eventName + "_check_changed", true, new Object[0]);
              }
            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


        });
    }

	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public boolean isCheckBoxChecked() {
        return cv.isChecked();
    }


    /**
     * setChecked with Animation
     * checked true if checked, false if unchecked
     */
    public void setChecked(boolean checked) {
       cv.setChecked(checked, true);
       cv.invalidate();
    }

    /**
     * checked  true if checked, false if unchecked
     * animation true with animation,false without animation
     */
    public void setChecked(boolean checked, boolean animation){
        cv.setChecked(checked, animation);
        cv.invalidate();
    }

    public void setStrokeWidth (int sw){
       cv.setStrokeWidth(sw);
       cv.invalidate();
    }



    public void setTickColor(int dhc){
        cv.setDrawHookColor(dhc);
        cv.invalidate();
    }


    public void setUncheckedOuterCircleColor(int dsc){
      cv.setDrawStrokeColor(dsc);
      cv.invalidate();
    }

    public void setCheckedOuterCircleColor(int occ){
       cv.setOuterCircleColor(occ);
       cv.invalidate();
    }

    public void setOuterCircleAlpha(int oca){
       cv.setOuterCircleAlpha(oca);
       cv.invalidate();
    }

    public void setInnerCircleAlpha(int ica){
       cv.setInnerCircleAlpha(ica);
       cv.invalidate();
    }

    public void setInnerCircleColor(int icc){
       cv.setInnerCircleColor(icc);
       cv.invalidate();
    }





}
